//+------------------------------------------------------------------+
//|                                              Angles_3_points.mq4 |
//|                                                              Oxy |
//|                                                  m-viva@inbox.ru |
//+------------------------------------------------------------------+
#property copyright "Oxy"
#property link      "m-viva@inbox.ru"
#property version   "1.00"
#property strict
#property indicator_chart_window
#define PI 3.1415926535897

enum newPoint {
   Pt1=1,    // point 1
   Pt2=2,    // point 2
   Pt3=3,    // point 3
};

struct angles_array
  {
   int      NUMangle;
   string   Point1_namePoint;
   double   Point1_price;
   datetime Point1_time;
   string   Point1_nameTextP;
   string   Point1_nameTextL;
   bool     Point1_NOTselection;
   string   Point2_namePoint;
   double   Point2_price;
   datetime Point2_time;
   string   Point2_nameTextP;
   string   Point2_nameTextA;
   bool     Point2_NOTselection;
   string   Point3_namePoint;
   double   Point3_price;
   datetime Point3_time;
   string   Point3_nameTextP;
   string   Point3_nameTextL;
   bool     Point3_NOTselection;
   string   Line1_name;
   string   Line2_name;
  };
//------- external parameters ---------------------------------------+
input string Txt         = "5 :1000/990 <-> 4 :100/990";    //   -:
input int    ModelPoint  = 1000;                                       //  :  !!!   
input int    ModelTime   = 990;                                        //  :   
input color  ColorSizes  = clrBlue;                                    //   /
input color  ColorPrices = clrGray;                                    //    
//------- global variables ------------------------------------------+
string   IndShortName = "Angles_3points";
//--- 
string ANGLE       = "Angle";
string POINT       = "Point";
string LINE        = "Line";
string POINT_TEXT  = "txt_point";
string SIZE_TEXT   = "txt_size";
string BID         = "~BID";
//---
newPoint      New_Point;
angles_array  AnglesArr[];
//---
string Btn_new_point  = "Btn_new_point";
string Btn_3_point    = "Btn_3_point";
string NearBtn_text1  = "NearBtn_text1";
string NearBtn_text2  = "NearBtn_text2";
int    Btn_width = 90;
int    Btn1_x = 100;
int    Btn1_y = 30;
int    BtnT_x = 100;
int    BtnT_y = 60;
int    Btn2_x = 100;
int    Btn2_y = 80;
//---
string WaitPointName;
bool   DeletedCurrentAngle;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(!CheckIndicator()) return(INIT_FAILED);
   if(ModelPoint<1) {Alert("      1"); return(INIT_FAILED);}
   if(ModelTime<1)  {Alert("      1"); return(INIT_FAILED);}   
   DeleteObjects();
   NEWAnglesArr();
   PutRightFBtn();   
   return(INIT_SUCCEEDED);
  }
bool CheckIndicator () {
  IndicatorShortName(IndShortName);
  int _ind = ChartIndicatorsTotal(0,0);
  int _num = 0; 
  for(int i=0; i<_ind; i++) {
    if(ChartIndicatorName(0,0,i)==IndShortName) _num++;  
    if(_num>1) return(false);
  }
  return (true);
}
void NEWAnglesArr() {
  ArrayResize(AnglesArr, 0);
  int _obj_s = ObjectsTotal();
  string NOTobject = "NOTobject";
  for(int i=_obj_s-1; i>=0; i--) {
    string _name = ObjectName(i);
    if(StringFind(_name, LINE)!=-1 || StringFind(_name, POINT_TEXT)!=-1 || StringFind(_name, SIZE_TEXT)!=-1) {
      if(ObjectFind(_name)==0)ObjectDelete(0, _name);
      continue;
    } 
    if(StringFind(_name, POINT)!=-1 && ObjectFind(_name)==0) {
      int n1 = StringFind(_name, "_"); if(n1==-1) continue;
      int ag = (int)StringSubstr(_name, 5, n1-5);
      int n2 = StringFind(_name, "~");
      int pt = 0;
      if(n2==-1) pt = (int)StringSubstr(_name, n1+5+1);
      else       pt = (int)StringSubstr(_name, n1+5+1, n2-(n1+5+1));
      int _size = ArraySize(AnglesArr);
      if(ag>_size) {_size=ag; ArrayResize(AnglesArr, _size);}
      if(pt==1) {
        AnglesArr[ag-1].Point1_namePoint=_name;
        AnglesArr[ag-1].Point1_NOTselection=false;
      }
      if(pt==2) {
        AnglesArr[ag-1].Point2_namePoint=_name;
        AnglesArr[ag-1].Point2_NOTselection=false;
      }
      if(pt==3) {
        AnglesArr[ag-1].Point3_namePoint=_name;
        AnglesArr[ag-1].Point3_NOTselection=false;
      }
      if(StringFind(AnglesArr[ag-1].Point1_namePoint, POINT)==-1) AnglesArr[ag-1].Point1_namePoint=NOTobject;
      if(StringFind(AnglesArr[ag-1].Point2_namePoint, POINT)==-1) AnglesArr[ag-1].Point2_namePoint=NOTobject;
      if(StringFind(AnglesArr[ag-1].Point3_namePoint, POINT)==-1) AnglesArr[ag-1].Point3_namePoint=NOTobject;
      AnglesArr[ag-1].NUMangle=ag;
    } 
  }
  CheckPoints_AnglesArr();
}
void PutRightFBtn() {
  New_Point = Pt1;
  WaitPointName = "";
  DeletedCurrentAngle = false;
  if(ObjectFind(Btn_new_point)==0) ObjectDelete(0, Btn_new_point);
  if(ObjectFind(Btn_new_point)!=0) ButtonCreate(Btn_new_point, POINT+" "+(string)New_Point, Btn1_x, Btn1_y, Btn_width);
}
//+------------------------------------------------------------------+
//| Custom indicator DEinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){
  if(reason!=8)DeleteObjects();
}
void DeleteObjects () {
  if(ObjectFind(Btn_new_point)==0)  ObjectDelete(0, Btn_new_point);
  if(ObjectFind(Btn_3_point)==0)    ObjectDelete(0, Btn_3_point);
  if(ObjectFind(NearBtn_text1)==0)  ObjectDelete(0, NearBtn_text1);
  if(ObjectFind(NearBtn_text2)==0)  ObjectDelete(0, NearBtn_text2);
  
  int _obj_s = ObjectsTotal();
  for(int i=_obj_s-1; i>=0; i--) {
    string _name = ObjectName(i);
    if(StringFind(_name, LINE)!=-1 || StringFind(_name, POINT_TEXT)!=-1 || StringFind(_name, SIZE_TEXT)!=-1) {
      if(ObjectFind(_name)==0)ObjectDelete(0, _name);
    }
  }
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   MoveBidPoint();
   return(rates_total);
  }
//+------------------------------------------------------------------+
void MoveBidPoint(){
  int _size = ArraySize(AnglesArr);
  for(int i=_size-1; i>=0; i--) {
    if(StringFind(AnglesArr[i].Point3_namePoint, BID)!=-1 && ObjectFind(0, AnglesArr[i].Point3_namePoint)==0 && AnglesArr[i].Point3_NOTselection) {
      datetime _time=Time[0];
      double   _price=Bid;
      if(ObjectMove(0,AnglesArr[i].Point3_namePoint,0,_time,_price)) {
        AnglesArr[i].Point3_time=_time;
        AnglesArr[i].Point3_price=_price; 
        //  
        if(ObjectFind(0,AnglesArr[i].Point3_nameTextP)==0) {
          ObjectMove(0, AnglesArr[i].Point3_nameTextP,0,_time,_price);
          ObjectSetString (0,AnglesArr[i].Point3_nameTextP,OBJPROP_TEXT,"   p3 - "+DoubleToSubstring(AnglesArr[i].Point3_price, Digits));
        }
        if(!AnglesArr[i].Point2_NOTselection) continue;
        // 
        if(ObjectFind(0,AnglesArr[i].Line2_name)==0) ObjectMove(0, AnglesArr[i].Line2_name,1,_time,_price);
        //         
        if(ObjectFind(0,AnglesArr[i].Point3_nameTextL)==0) {
          datetime _timeN  = PutLabelOnLine_Time(AnglesArr[i].Point2_time, AnglesArr[i].Point3_time); if(_timeN==-1) continue;
          double   _priceN = PutLabelOnLine_Price(AnglesArr[i].Point2_price, AnglesArr[i].Point3_price);
          
          int _points = pips_size_line(AnglesArr[i].Point2_price,AnglesArr[i].Point3_price);
          int _mins   = minutes_size_line(AnglesArr[i].Point2_time, AnglesArr[i].Point3_time);
          if(_mins!=-1) {
            _mins   += ((int)(TimeCurrent()-Time[0]))/60;
            if(ObjectMove(0,AnglesArr[i].Point3_nameTextL,0,_timeN,_priceN))
              ObjectSetString (0,AnglesArr[i].Point3_nameTextL,OBJPROP_TEXT,"   : "+(string)_mins+" min - "+(string)_points+" pips");
          }
        }
        //  
        if(ObjectFind(0,AnglesArr[i].Point2_nameTextA)==0) {
          int _grade = CalculateAngle(i);
          if(_grade!=-1)ObjectSetString (0,AnglesArr[i].Point2_nameTextA,OBJPROP_TEXT,"                         : "+(string)_grade);
        }
      }
    }
  }
}
//+------------------------------------------------------------------+
int CalculateAngle (int j) {
// : 2 up; 4 dn
// : 2 right; 4 left
// : 2 time; 4 points
// 3 - middle

//   243 242 232 222 223
// 244 \      |      /  224
// 344 -             -  324
// 444 /      |      \  424
//   443 442 432 422 423

  //  AnglesArr[j].Point2_price AnglesArr[j].Point2_time 
  
  //   
  int _num1_l1 = num_1(AnglesArr[j].Point1_price, AnglesArr[j].Point2_price);  if(_num1_l1==0) return(-1);
  int _num2_l1 = num_2(AnglesArr[j].Point1_time,  AnglesArr[j].Point2_time);   if(_num2_l1==0) return(-1);
  int _num3_l1 = num_3(AnglesArr[j].Point1_price, AnglesArr[j].Point2_price, AnglesArr[j].Point1_time,  AnglesArr[j].Point2_time, _num1_l1, _num2_l1);   
   if(_num3_l1==0) return(-1);

  //   
  int _num1_l2 = num_1(AnglesArr[j].Point3_price, AnglesArr[j].Point2_price);  if(_num1_l2==0) return(-1);
  int _num2_l2 = num_2(AnglesArr[j].Point3_time,  AnglesArr[j].Point2_time);   if(_num2_l2==0) return(-1);
  int _num3_l2 = num_3(AnglesArr[j].Point3_price, AnglesArr[j].Point2_price, AnglesArr[j].Point3_time,  AnglesArr[j].Point2_time, _num1_l2, _num2_l2);   
   if(_num3_l2==0) return(-1);
  
  int _min_size_line1  = minutes_size_line(AnglesArr[j].Point1_time, AnglesArr[j].Point2_time); if(_min_size_line1==-1) return(-1);
  int _min_size_line2  = minutes_size_line(AnglesArr[j].Point3_time, AnglesArr[j].Point2_time); if(_min_size_line2==-1) return(-1);
  int _pips_size_line1 = pips_size_line(AnglesArr[j].Point1_price, AnglesArr[j].Point2_price);
  int _pips_size_line2 = pips_size_line(AnglesArr[j].Point3_price, AnglesArr[j].Point2_price);
  //Print("LINE1 ", _num1_l1,_num2_l1,_num3_l1);
  //Print("LINE2 ", _num1_l2,_num2_l2,_num3_l2);
  double _ang=forCalculateAngle(_num1_l1,_num2_l1,_num3_l1,_min_size_line1,_pips_size_line1,_num1_l2,_num2_l2,_num3_l2,_min_size_line2,_pips_size_line2);
  int _angle1=(int)MathCeil(_ang);
  int _angle2=360-_angle1;
  int _angle = MathMin(_angle1,_angle2);
  
  return(_angle);
}
double forCalculateAngle(int num1_l1,int num2_l1,int num3_l1, int msl1, int psl1,  int num1_l2,int num2_l2,int num3_l2, int msl2, int psl2) {
  double _angle_calculate=0.0, _grades1=0.0, _grades2=0.0;
  int _angle=0;
  //---
  if((num2_l1==2 && (num3_l1==3 || num3_l1==4)) || (num2_l2==2 && (num3_l2==3 || num3_l2==4))) {
    _angle++;
    if (num2_l1==2 && (num3_l1==3 || num3_l1==4)) {
      if(num1_l1==2 && num3_l1==3) {_grades1=45;                     _angle_calculate=45+_grades1;}
      if(num1_l1==2 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate=45+_grades1; }
      if(num1_l1==3 && num3_l1==4) {_grades1=0;                      _angle_calculate=45+_grades1;}
      if(num1_l1==4 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate=45-_grades1; }
      if(num1_l1==4 && num3_l1==3) {_grades1=45;                     _angle_calculate=45-_grades1;}
    }
    if (num2_l2==2 && (num3_l2==3 || num3_l2==4)) {
      if(num1_l2==2 && num3_l2==3) {_grades2=45;                     _angle_calculate=45+_grades2;}
      if(num1_l2==2 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate=45+_grades2; }
      if(num1_l2==3 && num3_l2==4) {_grades2=0;                      _angle_calculate=45+_grades2;}
      if(num1_l2==4 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate=45-_grades2; }
      if(num1_l2==4 && num3_l2==3) {_grades2=45;                     _angle_calculate=45-_grades2;}    
    }
    if((num2_l1==2 && (num3_l1==3 || num3_l1==4)) && (num2_l2==2 && (num3_l2==3 || num3_l2==4))) {      
      if( (((num1_l1==2 && num3_l1==3) || (num1_l1==2 && num3_l1==4)) &&  ((num1_l2==4 && num3_l2==4) || (num1_l2==4 && num3_l2==3))) 
       || (((num1_l2==2 && num3_l2==3) || (num1_l2==2 && num3_l2==4)) &&  ((num1_l1==4 && num3_l1==4) || (num1_l1==4 && num3_l1==3)))){
        _angle_calculate = _grades1+_grades2;
      } else {
        _angle_calculate = MathMax(_grades1, _grades2) - MathMin(_grades1, _grades2);
      }
      return(_angle_calculate);
    }
  }
  //---
  if(_angle>0) {
    _angle++;
    if(num1_l1==4 && num3_l1==2) {
      if(num2_l1==2) {_grades1 =grades_UD(msl1, psl1); _angle_calculate +=45-_grades1; }
      if(num2_l1==3) {_grades1 = 0;                    _angle_calculate +=45+_grades1;}
      if(num2_l1==4) {_grades1 =grades_UD(msl1, psl1); _angle_calculate +=45+_grades1; }
      return(_angle_calculate);
    }
    if(num1_l2==4 && num3_l2==2) {
      if(num2_l2==2) {_grades2 =grades_UD(msl2, psl2); _angle_calculate +=45-_grades2; }
      if(num2_l2==3) {_grades2 = 0;                    _angle_calculate +=45+_grades2;}
      if(num2_l2==4) {_grades2 =grades_UD(msl2, psl2); _angle_calculate +=45+_grades2; }
      return(_angle_calculate);
    }    
    _angle_calculate+=90;
  } else {    
    if((num1_l1==4 && num3_l1==2) || (num1_l2==4 && num3_l2==2)) {    
      _angle++;  
      if (num1_l1==4 && num3_l1==2) {
        if(num2_l1==2) {_grades1 =grades_UD(msl1, psl1); _angle_calculate =45+_grades1; }
        if(num2_l1==3) {_grades1 = 0;                    _angle_calculate =45+_grades1;}
        if(num2_l1==4) {_grades1 =grades_UD(msl1, psl1); _angle_calculate =45-_grades1; }
      }
      if (num1_l2==4 && num3_l2==2) {
        if(num2_l2==2) {_grades2 =grades_UD(msl2, psl2); _angle_calculate =45+_grades2; }
        if(num2_l2==3) {_grades2 = 0;                    _angle_calculate =45+_grades2;}
        if(num2_l2==4) {_grades2 =grades_UD(msl2, psl2); _angle_calculate =45-_grades2; }
      }
      if((num1_l1==4 && num3_l1==2) && (num1_l2==4 && num3_l2==2)) {
        if((num2_l1==2 && num2_l2==4) || (num2_l1==4 && num2_l2==2)) {
          _angle_calculate = _grades1+_grades2;
        } else {
          _angle_calculate = MathMax(_grades1, _grades2) - MathMin(_grades1, _grades2);
        }
        return(_angle_calculate);
      }
    }
  }
  //---
  if(_angle>0) {
    _angle++;
    if (num2_l1==4 && (num3_l1==3 || num3_l1==4)) {
      if(num1_l1==4 && num3_l1==3) {_grades1 = 45;                   _angle_calculate +=45-_grades1;}
      if(num1_l1==4 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate +=45-_grades1; }
      if(num1_l1==3 && num3_l1==4) {_grades1 = 0;                    _angle_calculate +=45+_grades1;}
      if(num1_l1==2 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate +=45+_grades1; }
      if(num1_l1==2 && num3_l1==3) {_grades1 = 45;                   _angle_calculate +=45+_grades1;}
      return(_angle_calculate);
    }
    if (num2_l2==4 && (num3_l2==3 || num3_l2==4)) {
      if(num1_l2==4 && num3_l2==3) {_grades2 = 45;                   _angle_calculate +=45-_grades2;}
      if(num1_l2==4 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate +=45-_grades2; }
      if(num1_l2==3 && num3_l2==4) {_grades2 = 0;                    _angle_calculate +=45+_grades2;}
      if(num1_l2==2 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate +=45+_grades2; }
      if(num1_l2==2 && num3_l2==3) {_grades2 = 45;                   _angle_calculate +=45+_grades2;}
      return(_angle_calculate);
    }    
    _angle_calculate+=90;
  } else {
    if((num2_l1==4 && (num3_l1==3 || num3_l1==4)) || (num2_l2==4 && (num3_l2==3 || num3_l2==4))) { 
      _angle++;
      if (num2_l1==4 && (num3_l1==3 || num3_l1==4)) {
        if(num1_l1==4 && num3_l1==3) {_grades1 = 45;                   _angle_calculate +=45+_grades1;}
        if(num1_l1==4 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate +=45+_grades1; }
        if(num1_l1==3 && num3_l1==4) {_grades1 = 0;                    _angle_calculate +=45-_grades1;}
        if(num1_l1==2 && num3_l1==4) {_grades1 =grades_RL(msl1, psl1); _angle_calculate +=45-_grades1; }
        if(num1_l1==2 && num3_l1==3) {_grades1 = 45;                   _angle_calculate +=45-_grades1;}
      }
      if (num2_l2==4 && (num3_l2==3 || num3_l2==4)) {
        if(num1_l2==4 && num3_l2==3) {_grades2 = 45;                   _angle_calculate +=45+_grades2;}
        if(num1_l2==4 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate +=45+_grades2; }
        if(num1_l2==3 && num3_l2==4) {_grades2 = 0;                    _angle_calculate +=45-_grades2;}
        if(num1_l2==2 && num3_l2==4) {_grades2 =grades_RL(msl2, psl2); _angle_calculate +=45-_grades2; }
        if(num1_l2==2 && num3_l2==3) {_grades2 = 45;                   _angle_calculate +=45-_grades2;}
      }
      if((num2_l1==4 && (num3_l1==3 || num3_l1==4)) && (num2_l2==4 && (num3_l2==3 || num3_l2==4))) {
        if((((num1_l1==4 && num3_l1==3) || (num1_l1==4 && num3_l1==4)) && ((num1_l2==2 && num3_l2==3) || (num1_l2==2 && num3_l2==4))) 
        || (((num1_l2==4 && num3_l2==3) || (num1_l2==4 && num3_l2==4)) && ((num1_l1==2 && num3_l1==3) || (num1_l1==2 && num3_l1==4)))) {
          _angle_calculate = _grades1+_grades2;
        } else {
          _angle_calculate = MathMax(_grades1, _grades2) - MathMin(_grades1, _grades2);
        }
        return(_angle_calculate);
      }
    }
  }
  //---
  if(_angle>0) {
    _angle++;
    if(num1_l1==2 && num3_l1==2) { 
      if(num2_l1==4) {_grades1 =grades_UD(msl1, psl1); _angle_calculate +=45-_grades1; }
      if(num2_l1==3) {_grades1 = 0;                    _angle_calculate +=45+_grades1;}
      if(num2_l1==2) {_grades1 =grades_UD(msl1, psl1); _angle_calculate +=45+_grades1; }
      return(_angle_calculate);
    }
    if(num1_l2==2 && num3_l2==2) { 
      if(num2_l2==4) {_grades2 =grades_UD(msl2, psl2); _angle_calculate +=45-_grades2; }
      if(num2_l2==3) {_grades2 = 0;                    _angle_calculate +=45+_grades2;}
      if(num2_l2==2) {_grades2 =grades_UD(msl2, psl2); _angle_calculate +=45+_grades2; }
      return(_angle_calculate);
    }
  } else {    
    if((num1_l1==2 && num3_l1==2) && (num1_l2==2 && num3_l2==2)) { 
      _angle++; 
      if(num2_l1==4) {_grades1 =grades_UD(msl1, psl1);}
      if(num2_l1==3) {_grades1 = 0;}
      if(num2_l1==2) {_grades1 =grades_UD(msl1, psl1);}
      if(num2_l2==4) {_grades2 =grades_UD(msl2, psl2);}
      if(num2_l2==3) {_grades2 = 0;}
      if(num2_l2==2) {_grades2 =grades_UD(msl2, psl2);}
      if((num2_l1==4 && num2_l2==2) || (num2_l1==2 && num2_l2==4)) {
        _angle_calculate = _grades1+_grades2;
      } else {
        _angle_calculate = MathMax(_grades1, _grades2) - MathMin(_grades1, _grades2);
      }
      return(_angle_calculate);
    }
  }
  return(-1);
}
double grades_RL (int mins, int pips) {
  double _cathetus = ((double)mins*(double)ModelPoint)/(double)ModelTime;  
  double ratio     = (double)pips/(double)_cathetus;
  double _grades   = (MathArctan(ratio)*180.0)/PI;
  //Print("grades_RL = ", _grades);
  return(_grades);
}
double grades_UD (int mins, int pips) {
  double _cathetus = ((double)pips*(double)ModelTime)/(double)ModelPoint;
  double ratio     = (double)mins/(double)_cathetus;
  double _grades   =  (MathArctan(ratio)*180.0)/PI;
  //Print("grades_UD = ", _grades);
  return(_grades);
}
int num_3 (double price1, double priceA, datetime time1, datetime timeA, int n1, int n2) {
  int _num = 0;
  if(n1==2 && n2==3) _num=2;
  if(n1==4 && n2==3) _num=2;
  if(n1==3 && n2==2) _num=4;
  if(n1==3 && n2==4) _num=4;
  if(_num!=0) return(_num);
  
  datetime _t3  = time1;
  int _mins = minutes_size_line(timeA, time1); if(_mins==-1) return(_num);
  double _pp   = ((double)_mins*(double)ModelPoint)/(double)ModelTime;
  //22 -    
  if(n1==2 && n2==2) {
    double _pr3 = NormalizeDouble(priceA+_pp*Point, Digits);
    if(price1==_pr3) _num=3;
    if(price1>_pr3)  _num=2;
    if(price1<_pr3)  _num=4;
  }
  //42 -   
  if(n1==4 && n2==2) {
    double _pr3 = NormalizeDouble(priceA-_pp*Point, Digits);
    if(price1==_pr3) _num=3;
    if(price1>_pr3)  _num=4;
    if(price1<_pr3)  _num=2;
  }
  //44 -   
  if(n1==4 && n2==4) {
    double _pr3 = NormalizeDouble(priceA-_pp*Point, Digits);
    if(price1==_pr3) _num=3;
    if(price1>_pr3)  _num=4;
    if(price1<_pr3)  _num=2;
  }
  //24 -   
  if(n1==2 && n2==4) {
    double _pr3 = NormalizeDouble(priceA+_pp*Point, Digits);
    if(price1==_pr3) _num=3;
    if(price1>_pr3)  _num=2;
    if(price1<_pr3)  _num=4;
  }
  return(_num);
}
int num_1 (double price1, double priceA) {
  int _num = 0;
  if(price1>priceA) _num=2;
  if(price1==priceA)_num=3;
  if(price1<priceA) _num=4;
  return(_num);
}
int num_2 (datetime time1, datetime timeA) {
  int _num = 0;
  if(time1>timeA) _num=2;
  if(time1==timeA)_num=3;
  if(time1<timeA) _num=4;
  return(_num);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
    CheckPoints_AnglesArr();
    if(id==CHARTEVENT_OBJECT_CLICK) {           
      if(ObjectFind(Btn_new_point)==0 && sparam==Btn_new_point) {      
        
        if(ObjectGetInteger(0,Btn_new_point,OBJPROP_STATE)) {    
          if (PutNewPoint()) { 
            DeletedCurrentAngle=false;           
            if(ObjectFind(Btn_3_point)==0) ObjectDelete(0, Btn_3_point);
            LabelCreate(NearBtn_text1,BtnT_x-Btn_width,BtnT_y,   " ",   clrGray); 
            LabelCreate(NearBtn_text2,BtnT_x-Btn_width,BtnT_y+14,"  ",clrGray);
          } else {
            //---     
            ObjectSetInteger(0,Btn_new_point,OBJPROP_STATE,false);
          }
        } else {          
          //---     
          if(!DeletedCurrentAngle)ObjectSetInteger(0,Btn_new_point,OBJPROP_STATE,true);
        }    
      }  
      if(ObjectFind(Btn_3_point)==0 && sparam==Btn_3_point) {
        PutBidPoint();
      }  
    }
  }
void UnDropBtn(int numPoint, bool newAngle=false) {
  if(ObjectFind(NearBtn_text1)==0)  ObjectDelete(0, NearBtn_text1);
  if(ObjectFind(NearBtn_text2)==0)  ObjectDelete(0, NearBtn_text2);
  if(ObjectFind(Btn_3_point)==0)    ObjectDelete(0, Btn_3_point);
  
  if(newAngle) {New_Point=Pt1; WaitPointName=""; DeletedCurrentAngle=true;}
  else {
    DeletedCurrentAngle=false;
    if(numPoint==New_Point) {
      if(New_Point==Pt3) {New_Point=Pt1; WaitPointName="";}
      else New_Point++;
    }   
  }  
  ObjectSetString(0,Btn_new_point,OBJPROP_TEXT,POINT+" "+(string)New_Point);
  //---     
  ObjectSetInteger(0,Btn_new_point,OBJPROP_STATE,false);
  
  if(New_Point==Pt3) {
    ButtonCreate(Btn_3_point, "3 -> Bid", Btn2_x, Btn2_y, Btn_width);
  }
}
bool PutNewPoint() {
  int numAngle = GetNumAngle((int)New_Point);
  string _name = ANGLE+(string)numAngle+"_"+POINT+(string)New_Point;  
  int _x = (int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS)-Btn1_x-40;
  datetime dt = 0; double pr = 0; int window=0;
  if(!ChartXYToTimePrice(0, _x, Btn1_y+15, window, dt, pr)) return(false);
  if(!TextCreate(_name, dt, pr, "0", clrRed, "Gill Sans Ultra Bold", 8, ANCHOR_CENTER, true, false)) return(false);
  AddPoint_inAnglesArr((int)New_Point, _name, numAngle);
  WaitPointName = _name;
  return(true);
}
bool PutBidPoint(){
  int numAngle = GetNumAngle((int)New_Point); 
  string _name = ANGLE+(string)numAngle+"_"+POINT+(string)New_Point+BID; 
  RefreshRates();
  if(!TextCreate(_name, Time[0], Bid, "0", clrRed, "Gill Sans Ultra Bold", 8, ANCHOR_CENTER, true, false)) return(false);
  AddPoint_inAnglesArr((int)New_Point, _name);
  WaitPointName = _name;
  ObjectSetInteger(0, _name, OBJPROP_SELECTED, 0);
  CheckPoints_AnglesArr(ArraySize(AnglesArr)-1);
  return(true);
}
bool canDeleteThisAngle (int i, string name) {
  int _na = AnglesArr[i].NUMangle;
  int n1 = StringFind(name, "_"); if(n1==-1) return(false);
  int ag = (int)StringSubstr(name, 5, n1-5);
  if(_na==ag) return(true);
  return(false);
}
//+------------------------------------------------------------------+
void CheckPoints_AnglesArr(int j=-1) {
  int _size = ArraySize(AnglesArr);
  if(j>-1) _size=j+1;  //  
  else j=0;  
  string _name;
  for(int i=_size-1; i>=j; i--) {
    //---
    _name = AnglesArr[i].Point1_namePoint; 
    if(_name=="" || ObjectFind(0, _name)!=0) {
      bool _deleteThisAngle = canDeleteThisAngle(i, WaitPointName);
      DeleteAngle_inAnglesArr(i);
      if(_deleteThisAngle) UnDropBtn(1, true);
      continue;
    }
    if(AnglesArr[i].Point1_NOTselection==false) {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==0) {
        if(WaitPointName==_name) UnDropBtn(1);
        AnglesArr[i].Point1_NOTselection=true;
        AnglesArr[i].Point1_price          =ObjectGetDouble (0, _name, OBJPROP_PRICE);
        AnglesArr[i].Point1_time =(datetime)ObjectGetInteger(0, _name, OBJPROP_TIME);
        AddTextNearPoint(i, 1);
        AddLine2points(i, 1);
        AddSizePoints(i, 1);
      }
    } else {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==1) {
        AnglesArr[i].Point1_NOTselection=false;
        AnglesArr[i].Point1_price=0;
        AnglesArr[i].Point1_time=0;
        DeleteTextNearPoint(i, 1);
        DeleteLine2points(i, 1);  
        DeleteSizePoints(i, 1);      
      }
    }
    //---
    _name = AnglesArr[i].Point2_namePoint; 
    if(_name=="") continue; 
    if(ObjectFind(0, _name)!=0) {
      bool _deleteThisAngle = canDeleteThisAngle(i, WaitPointName);
      DeleteAngle_inAnglesArr(i);
      if(_deleteThisAngle) UnDropBtn(2, true);
      continue;
    }
    if(AnglesArr[i].Point2_NOTselection==false) {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==0) {
        if(WaitPointName==_name) UnDropBtn(2);
        AnglesArr[i].Point2_NOTselection=true;
        AnglesArr[i].Point2_price          =ObjectGetDouble (0, _name, OBJPROP_PRICE);
        AnglesArr[i].Point2_time =(datetime)ObjectGetInteger(0, _name, OBJPROP_TIME);
        AddTextNearPoint(i, 2);
        AddLine2points(i, 2);
        AddSizePoints(i, 2);
      }
    } else {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==1) {
        AnglesArr[i].Point2_NOTselection=false;
        AnglesArr[i].Point2_price=0;
        AnglesArr[i].Point2_time=0;
        DeleteTextNearPoint(i, 2);
        DeleteLine2points(i, 2);
        DeleteSizePoints(i, 2);
      }
    }
    //---
    _name = AnglesArr[i].Point3_namePoint; 
    if(_name=="") continue; 
    if(ObjectFind(0, _name)!=0) {
      bool _deleteThisAngle = canDeleteThisAngle(i, WaitPointName);
      DeleteAngle_inAnglesArr(i);
      if(_deleteThisAngle) UnDropBtn(3, true);
      continue;
    }
    if(AnglesArr[i].Point3_NOTselection==false) {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==0) {
        if(WaitPointName==_name) UnDropBtn(3);
        AnglesArr[i].Point3_NOTselection=true;
        AnglesArr[i].Point3_price          =ObjectGetDouble (0, _name, OBJPROP_PRICE);
        AnglesArr[i].Point3_time =(datetime)ObjectGetInteger(0, _name, OBJPROP_TIME);
        AddTextNearPoint(i, 3);
        AddLine2points(i, 3);
        AddSizePoints(i, 3);
      }
    } else {
      if(ObjectGetInteger(0, _name, OBJPROP_SELECTED)==1) {
        AnglesArr[i].Point3_NOTselection=false;
        AnglesArr[i].Point3_price=0;
        AnglesArr[i].Point3_time=0;
        DeleteTextNearPoint(i, 3);
        DeleteLine2points(i, 3);
        DeleteSizePoints(i, 3);
      }
    }    
    //---
  }
}
void AddSizePoints(int j, int point) {
  string _name=ANGLE+(string)AnglesArr[j].NUMangle+"_"+SIZE_TEXT;
  
  if(StringFind(AnglesArr[j].Point2_nameTextA, SIZE_TEXT)==-1 
  && AnglesArr[j].Point1_NOTselection && AnglesArr[j].Point2_NOTselection && AnglesArr[j].Point3_NOTselection) {
    int _grade = CalculateAngle(j);
    if(_grade!=-1)
      if(TextCreate(_name+"2", AnglesArr[j].Point2_time, AnglesArr[j].Point2_price, "                         : "+(string)_grade,ColorSizes))
        AnglesArr[j].Point2_nameTextA=_name+"2";
  }  
  if((point==1 || point==2) && StringFind(AnglesArr[j].Point1_nameTextL, SIZE_TEXT)==-1) {
    if(AnglesArr[j].Point1_NOTselection && AnglesArr[j].Point2_NOTselection) {
      datetime _timeN  = PutLabelOnLine_Time(AnglesArr[j].Point1_time, AnglesArr[j].Point2_time); if(_timeN==-1) return;
      double   _priceN = PutLabelOnLine_Price(AnglesArr[j].Point1_price,AnglesArr[j].Point2_price);
      int      _points = pips_size_line(AnglesArr[j].Point1_price,AnglesArr[j].Point2_price); 
      int      _mins   = minutes_size_line(AnglesArr[j].Point1_time, AnglesArr[j].Point2_time); if(_mins==-1) return;
      if(TextCreate(_name+"1", _timeN, _priceN,"   : "+(string)_mins+" min - "+(string)_points+" pips",ColorSizes))
         AnglesArr[j].Point1_nameTextL=_name+"1";
    }
  } 
  if((point==2 || point==3) && StringFind(AnglesArr[j].Point3_nameTextL, SIZE_TEXT)==-1) {
    if(AnglesArr[j].Point2_NOTselection && AnglesArr[j].Point3_NOTselection) {
      datetime _timeN  = PutLabelOnLine_Time(AnglesArr[j].Point3_time, AnglesArr[j].Point2_time); if(_timeN==-1) return;
      double   _priceN = PutLabelOnLine_Price(AnglesArr[j].Point3_price,AnglesArr[j].Point2_price);
      int      _points = pips_size_line(AnglesArr[j].Point3_price,AnglesArr[j].Point2_price); 
      int      _mins   = minutes_size_line(AnglesArr[j].Point3_time, AnglesArr[j].Point2_time); if(_mins==-1) return;
      if(TextCreate(_name+"3", _timeN, _priceN,"   : "+(string)_mins+" min - "+(string)_points+" pips",ColorSizes))
         AnglesArr[j].Point3_nameTextL=_name+"3";
    }
  }
}
void DeleteSizePoints(int j, int point) {
  if(ObjectFind(AnglesArr[j].Point2_nameTextA)==0)  ObjectDelete(0, AnglesArr[j].Point2_nameTextA);
    AnglesArr[j].Point2_nameTextA="";
  //---    
  if(point==1) {
    if(ObjectFind(AnglesArr[j].Point1_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point1_nameTextL);
    AnglesArr[j].Point1_nameTextL="";
    return;
  }
  if(point==2) {
    if(ObjectFind(AnglesArr[j].Point1_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point1_nameTextL);
    AnglesArr[j].Point1_nameTextL="";
    if(ObjectFind(AnglesArr[j].Point3_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point3_nameTextL);
    AnglesArr[j].Point3_nameTextL="";
    return;
  }
  if(point==3) {
    if(ObjectFind(AnglesArr[j].Point3_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point3_nameTextL);
    AnglesArr[j].Point3_nameTextL="";
    return;
  }
}
void AddLine2points (int j, int point) {
  string _name=ANGLE+(string)AnglesArr[j].NUMangle+"_"+LINE;
  if((point==1 || point==2) && StringFind(AnglesArr[j].Line1_name, LINE)==-1) {
    if(AnglesArr[j].Point1_NOTselection && AnglesArr[j].Point2_NOTselection) {
      if(TrendCreate(_name+"1", AnglesArr[j].Point1_time, AnglesArr[j].Point1_price, AnglesArr[j].Point2_time, AnglesArr[j].Point2_price))
        AnglesArr[j].Line1_name=_name+"1";
    }
  }
  if((point==2 || point==3) && StringFind(AnglesArr[j].Line2_name, LINE)==-1) {
    if(AnglesArr[j].Point2_NOTselection && AnglesArr[j].Point3_NOTselection) {
      if(TrendCreate(_name+"2", AnglesArr[j].Point2_time, AnglesArr[j].Point2_price, AnglesArr[j].Point3_time, AnglesArr[j].Point3_price))
        AnglesArr[j].Line2_name=_name+"2";
    }
  }
}
void DeleteLine2points (int j, int point) {
  if(point==1) {
    if(ObjectFind(AnglesArr[j].Line1_name)==0)  ObjectDelete(0, AnglesArr[j].Line1_name);
    AnglesArr[j].Line1_name="";
    return;
  }
  if(point==2) {
    if(ObjectFind(AnglesArr[j].Line1_name)==0)  ObjectDelete(0, AnglesArr[j].Line1_name);
    AnglesArr[j].Line1_name="";
    if(ObjectFind(AnglesArr[j].Line2_name)==0)  ObjectDelete(0, AnglesArr[j].Line2_name);
    AnglesArr[j].Line2_name="";
    return;
  }
  if(point==3) {
    if(ObjectFind(AnglesArr[j].Line2_name)==0)  ObjectDelete(0, AnglesArr[j].Line2_name);
    AnglesArr[j].Line2_name="";
    return;
  }
}
void AddTextNearPoint(int j, int point) {
  string _name=ANGLE+(string)AnglesArr[j].NUMangle+"_"+POINT_TEXT;
  if(point==1) {
    if(TextCreate(_name+"1", AnglesArr[j].Point1_time, AnglesArr[j].Point1_price, "   p1 - "+DoubleToSubstring(AnglesArr[j].Point1_price, Digits),ColorPrices))
               AnglesArr[j].Point1_nameTextP=_name+"1"; 
    return;
  }
  if(point==2) {
    if(TextCreate(_name+"2", AnglesArr[j].Point2_time, AnglesArr[j].Point2_price, "   p2 - "+DoubleToSubstring(AnglesArr[j].Point2_price, Digits),ColorPrices))
               AnglesArr[j].Point2_nameTextP=_name+"2";  
    return;
  }
  if(point==3) {
    if(TextCreate(_name+"3", AnglesArr[j].Point3_time, AnglesArr[j].Point3_price, "   p3 - "+DoubleToSubstring(AnglesArr[j].Point3_price, Digits),ColorPrices))
               AnglesArr[j].Point3_nameTextP=_name+"3";  
    return;
  }
}
void DeleteTextNearPoint(int j, int point) {
  if(point==1) {
    if(ObjectFind(AnglesArr[j].Point1_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point1_nameTextP);
    AnglesArr[j].Point1_nameTextP="";
    return;
  }
  if(point==2) {
    if(ObjectFind(AnglesArr[j].Point2_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point2_nameTextP);
    AnglesArr[j].Point2_nameTextP="";
    return;
  }
  if(point==3) {
    if(ObjectFind(AnglesArr[j].Point3_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point3_nameTextP);
    AnglesArr[j].Point3_nameTextP="";
    return;
  }
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double PutLabelOnLine_Price (double price1, double price2) {
  double _priceN = NormalizeDouble((price1+price2)/2,Digits);
  return (_priceN);
}
datetime PutLabelOnLine_Time (datetime time1, datetime time2) {
  int _bar1 = iBarShift(NULL, 0, time1, true); if(_bar1==-1) return(-1);
  int _bar2 = iBarShift(NULL, 0, time2, true); if(_bar2==-1) return(-1);
  datetime _timeN = Time[(int)((_bar1+_bar2)/2)];
  return(_timeN);
}
int pips_size_line (double price1, double price2) {
  int pips = (int)MathCeil((MathMax(price1,price2)-MathMin(price1,price2))/Point);
  return(pips);
}
int minutes_size_line (datetime time1, datetime time2) {
  int _bar1 = iBarShift(NULL, 0, time1, true); if(_bar1==-1) return(-1);
  int _bar2 = iBarShift(NULL, 0, time2, true); if(_bar2==-1) return(-1);
  int _mins =(int)MathCeil((MathMax(_bar1,_bar2)-MathMin(_bar1,_bar2))*Period());
  return(_mins);
}
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
void DeleteAngle_inAnglesArr(int j) {
  if(ObjectFind(AnglesArr[j].Point1_namePoint)==0)  ObjectDelete(0, AnglesArr[j].Point1_namePoint);
  if(ObjectFind(AnglesArr[j].Point1_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point1_nameTextP);
  if(ObjectFind(AnglesArr[j].Point1_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point1_nameTextL);
  if(ObjectFind(AnglesArr[j].Point2_namePoint)==0)  ObjectDelete(0, AnglesArr[j].Point2_namePoint);
  if(ObjectFind(AnglesArr[j].Point2_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point2_nameTextP);
  if(ObjectFind(AnglesArr[j].Point2_nameTextA)==0)  ObjectDelete(0, AnglesArr[j].Point2_nameTextA);
  if(ObjectFind(AnglesArr[j].Point3_namePoint)==0)  ObjectDelete(0, AnglesArr[j].Point3_namePoint);
  if(ObjectFind(AnglesArr[j].Point3_nameTextP)==0)  ObjectDelete(0, AnglesArr[j].Point3_nameTextP);
  if(ObjectFind(AnglesArr[j].Point3_nameTextL)==0)  ObjectDelete(0, AnglesArr[j].Point3_nameTextL);
  if(ObjectFind(AnglesArr[j].Line1_name)==0)  ObjectDelete(0, AnglesArr[j].Line1_name);
  if(ObjectFind(AnglesArr[j].Line2_name)==0)  ObjectDelete(0, AnglesArr[j].Line2_name);
  DeleteNotHaveAngle_inArray(j);
}

void DeleteNotHaveAngle_inArray (int k) {  
  int _size = ArraySize(AnglesArr);
  while(k<_size) {
    if(k==_size-1) {AnglesArr[k].NUMangle=-1; break;} 
     AnglesArr[k].NUMangle           =AnglesArr[k+1].NUMangle;
     AnglesArr[k].Point1_namePoint   =AnglesArr[k+1].Point1_namePoint;
     AnglesArr[k].Point1_price       =AnglesArr[k+1].Point1_price;
     AnglesArr[k].Point1_time        =AnglesArr[k+1].Point1_time;
     AnglesArr[k].Point1_nameTextP   =AnglesArr[k+1].Point1_nameTextP;
     AnglesArr[k].Point1_nameTextL   =AnglesArr[k+1].Point1_nameTextL;
     AnglesArr[k].Point1_NOTselection=AnglesArr[k+1].Point1_NOTselection;
     AnglesArr[k].Point2_namePoint   =AnglesArr[k+1].Point2_namePoint;
     AnglesArr[k].Point2_price       =AnglesArr[k+1].Point2_price;
     AnglesArr[k].Point2_time        =AnglesArr[k+1].Point2_time;
     AnglesArr[k].Point2_nameTextP   =AnglesArr[k+1].Point2_nameTextP;
     AnglesArr[k].Point2_nameTextA   =AnglesArr[k+1].Point2_nameTextA;
     AnglesArr[k].Point2_NOTselection=AnglesArr[k+1].Point2_NOTselection;
     AnglesArr[k].Point3_namePoint   =AnglesArr[k+1].Point3_namePoint;
     AnglesArr[k].Point3_price       =AnglesArr[k+1].Point3_price;
     AnglesArr[k].Point3_time        =AnglesArr[k+1].Point3_time;
     AnglesArr[k].Point3_nameTextP   =AnglesArr[k+1].Point3_nameTextP;
     AnglesArr[k].Point3_nameTextL   =AnglesArr[k+1].Point3_nameTextL;
     AnglesArr[k].Point3_NOTselection=AnglesArr[k+1].Point3_NOTselection;
     AnglesArr[k].Line1_name         =AnglesArr[k+1].Line1_name;
     AnglesArr[k].Line2_name         =AnglesArr[k+1].Line2_name; 
    k++;
  }
  int j = _size-1;
  while(j>=0) {
    if(AnglesArr[j].NUMangle==-1) {ArrayResize(AnglesArr, j); return;}
    j--;
  }
}
int GetNumAngle (int numPoint) {
  int NUMangle=1;
  int _size = ArraySize(AnglesArr);
  if(_size==0) return(NUMangle);
  if(numPoint==1)NUMangle = AnglesArr[_size-1].NUMangle+1;
  else NUMangle = AnglesArr[_size-1].NUMangle;
  return(NUMangle);
}
void AddPoint_inAnglesArr(int nPoint, string _name, int NUMangle=-1) {
  int _size = ArraySize(AnglesArr);
  if(nPoint==1) {
    _size++; ArrayResize(AnglesArr, _size);     
    AnglesArr[_size-1].Point1_namePoint    = _name;
    AnglesArr[_size-1].Point2_namePoint    = "";
    AnglesArr[_size-1].Point3_namePoint    = "";
    AnglesArr[_size-1].Point1_NOTselection = false;
    AnglesArr[_size-1].Point2_NOTselection = false;
    AnglesArr[_size-1].Point3_NOTselection = false;
  }
  if(nPoint==2) {
    AnglesArr[_size-1].Point2_namePoint    = _name;
    AnglesArr[_size-1].Point2_NOTselection = false;
  }
  if(nPoint==3) {
    AnglesArr[_size-1].Point3_namePoint    = _name;
    AnglesArr[_size-1].Point3_NOTselection = false;
  }
  if(NUMangle!=-1) AnglesArr[_size-1].NUMangle=NUMangle;  
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
bool ButtonCreate(const string            name="Button",             //     
                  const string            text="CLOSE",              //                
                  const int               x=100,                     //    X
                  const int               y=30,                      //    Y
                  const int               width=90,                  //  
                  const int               height=28,                 //  
                  const ENUM_BASE_CORNER  corner=CORNER_RIGHT_UPPER, //                      
                  const string            font="Arial",              // 
                  const int               font_size=14,              //  
                  const color             clr=clrFireBrick,          //  
                  const color             back_clr=C'236,233,216',   //  
                  const color             border_clr=clrNONE,        //  
                  const bool              state=false,               // /
                  const bool              back=false,                //   
                  const bool              selection=false,           //   
                  const bool              hidden=true,               //    
                  const long              z_order=0,                 //    
                  const int               sub_window=0,              //  
                  const long              chart_ID=0)                // ID 
  {
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0)) {
     Print(__FUNCTION__, ":    !   = ",GetLastError());
     return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool LabelCreate(const string            name="Label",              //  
                 const int               x=0,                       //    X
                 const int               y=0,                       //    Y
                 const string            text="Label",              // 
                 const color             clr=clrRed,                // 
                 const ENUM_BASE_CORNER  corner=CORNER_RIGHT_UPPER, //                     
                 const string            font="Arial",              // 
                 const int               font_size=10,              //                   
                 const double            angle=0.0,                 //  
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_UPPER, //  
                 const bool              back=true,                 //   
                 const bool              selection=false,           //   
                 const bool              hidden=true,               //    
                 const long              z_order=0,                 //    
                 const long              chart_ID=0,                // ID 
                 const int               sub_window=0)              //  
                 
  {
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0)) {
      Print(__FUNCTION__, ":     !   = ",GetLastError());
      return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetDouble (chart_ID,name,OBJPROP_ANGLE,angle);
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//|   ""                                           | 
//+------------------------------------------------------------------+
bool TextCreate(const string            name="Text",               //  
                datetime                time=0,                    //   
                double                  price=0,                   //   
                const string            text="0",                  //  
                const color             clr=clrGray,               // 
                const string            font="Tahoma",             // 
                const int               font_size=10,              //                 
                const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT,        //  
                const bool              selection=false,           //   
                const bool              hidden=true,               //    
                const double            angle=0.0,                 //  
                const bool              back=false,                //     
                const long              z_order=0,                 //    
                const long              chart_ID=0,                // ID 
                const int               sub_window=0)              //  
  {
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,sub_window,time,price)) {
      Print(__FUNCTION__,":     \"\"!   = ",GetLastError());
      return(false);
   }
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetDouble (chart_ID,name,OBJPROP_ANGLE,angle);
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
bool TrendCreate(const string          name="TrendLine",  //                   
                 datetime              time1=0,           //   
                 double                price1=0,          //   
                 datetime              time2=0,           //   
                 double                price2=0,          //   
                 const color           clr=clrGray,       //  
                 const int             width=1,           //  
                 const ENUM_LINE_STYLE style=STYLE_SOLID, //    
                 const bool            ray_right=false,   //                  
                 const bool            back=true,         //   
                 const bool            selection=false,   //                    
                 const bool            hidden=true,       //    
                 const long            z_order=0,         //    
                 const long            chart_ID=0,        // ID 
                 const int             sub_window=0)      //  
  {
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,sub_window,time1,price1,time2,price2)) {
      Print(__FUNCTION__, ":     !   = ",GetLastError());
      return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY_RIGHT,ray_right);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//  DOUBLE                                                   |
//+------------------------------------------------------------------+
string DoubleToSubstring (double _toString, int _afterPoint=5) {
  string _txt = (string)_toString;
  int _i      = StringFind(_txt, ".", 0); 
  if(_i!=-1)  
    _txt      =  StringSubstr(_txt, 0, _i+_afterPoint+1);
  return(_txt);
}
//+------------------------------------------------------------------+